*
* Thexder
* (c) 1987, Sierra
* (u) 2016, Brutal Deluxe Software
*

	mx	%00
	rel
	dsk	DISKSEG.L
	lst	off

	use	HACK.E.S
	use	DISKSEG.E.S
	use	DISKSEG.X.S

*------------------------------

L040000  ENT		; TITLE.PIC
         REP   #$20
         JSL   GSOS
         DW    $0010      ; Open
         ADRL  L03C7B6
         LDA   L03C7B6
         STA   L03C7D1
         STA   L03C8A7
         JSL   GSOS
         DW    $0012      ; Read
         ADRL  L03C7D1
         JSL   GSOS
         DW    $0014      ; Close
         ADRL  L03C8A7
         JSL   L04002E
         RTL

L04002E  ENT		; LOGO.PIC
         JSL   GSOS
         DW    $0010      ; Open
         ADRL  L03C7DF
         LDA   L03C7DF
         STA   L03C7F9
         STA   L03C8A7
         JSL   GSOS
         DW    $0012      ; Read
         ADRL  L03C7F9
         JSL   GSOS
         DW    $0014      ; Close
         ADRL  L03C8A7
         RTL

L040056  ENT		; CREDIT.PIC
         JSL   GSOS
         DW    $0010      ; Open
         ADRL  L03C807
         LDA   L03C807
         STA   L03C823
         STA   L03C8A7
         JSL   GSOS
         DW    $0012      ; Read
         ADRL  L03C823
         JSL   GSOS
         DW    $0014      ; Close
         ADRL  L03C8A7
         RTL

*
* DEAD CODE?
*

*         JSL   GSOS
*         DW    $0010      ; Open
*         ADRL  L03C831
*         LDA   L03C831
*         STA   L03C84A
*         STA   L03C8A7
*         JSL   GSOS
*         DW    $0012      ; Read
*         ADRL  L03C84A
*         JSL   GSOS
*         DW    $0014      ; Close
*         ADRL  L03C8A7
*         SEP   #$20
*         SEI
*         LDA   #$7F
*         STAL  SOUNDCTL
*         LDX   #$0000
*         TXA
*         STAL  SOUNDADRL
*         STAL  SOUNDADRH
*L0400BA  LDAL  ptrE12000,X
*         STAL  SOUNDDATA
*         INX
*         CPX   #$7800
*         BNE   L0400BA
*         CLI
*
*         REP   #$20
*         JSL   GSOS
*         DW    $0010      ; Open
*         ADRL  L03C858
*         LDA   L03C858
*         STA   L03C871
*         STA   L03C8A7
*         JSL   GSOS
*         DW    $0012      ; Read
*         ADRL  L03C871
*         JSL   GSOS
*         DW    $0014      ; Close
*         ADRL  L03C8A7
*         SEP   #$20
*         SEI
*         LDA   #$7F
*         STAL  SOUNDCTL
*         LDX   #$0000
*         TXA
*         STAL  SOUNDADRL
*         LDA   #$80
*         STAL  SOUNDADRH
*L040109  LDAL  ptrE12000,X
*         STAL  SOUNDDATA
*         INX
*         CPX   #$7800
*         BNE   L040109
*         CLI
*         REP   #$20
*         RTL

L04011B  ENT		; GSALPHA
         REP   #$20
         JSL   GSOS
         DW    $0010      ; Open
         ADRL  L03C8FB
         LDA   L03C8FB
         STA   L03C914
         STA   L03C922
         JSL   GSOS
         DW    $0012      ; Read
         ADRL  L03C914
         JSL   GSOS
         DW    $0014      ; Close
         ADRL  L03C922
         RTL

L040145  ENT		; THEX.PIC
         REP   #$20
         JSL   GSOS
         DW    $0010      ; Open
         ADRL  L03C87F
         LDA   L03C87F
         STA   L03C899
         STA   L03C8A7
         JSL   GSOS
         DW    $0012      ; Read
         ADRL  L03C899
         JSL   GSOS
         DW    $0014      ; Close
         ADRL  L03C8A7

         JSL   GSOS	; ROBOT.DAT
         DW    $0010      ; Open
         ADRL  L03C8A9
         LDA   L03C8A9
         STA   L03C8C4
         STA   L03C8D2
         JSL   GSOS
         DW    $0012      ; Read
         ADRL  L03C8C4
         JSL   GSOS
         DW    $0014      ; Close
         ADRL  L03C8D2

         JSL   GSOS	; DYING
         DW    $0010      ; Open
         ADRL  L03C8D4
         LDA   L03C8D4
         STA   L03C8EB
         STA   L03C8F9
         JSL   GSOS
         DW    $0012      ; Read
         ADRL  L03C8EB
         JSL   GSOS
         DW    $0014      ; Close
         ADRL  L03C8F9
         RTL

*
* LOAD LEVEL DATA
*

L0401BD  ENT
         REP   #$20
         LDA   L03CBA3
         INC
         STA   L03CBA3
         CMP   #$0011
         BNE   L0401D1
         LDA   #$0002
         STA   L03CBA3
L0401D1  ASL
         TAX
         LDA   L03CA5F,X
         STAL  L030652
         LDA   L03CA81,X
         STAL  L030654
         LDA   L03CAC3,X
         STAL  L03065E
         SED
         LDA   L03CBA7
         CLC
         ADC   #$0001
         STA   L03CBA7
         LDX   #$7860
         JSL   L0123A7
         SED
         LDA   L03CBA5
         CLC
         ADC   #$0001
         STA   L03CBA5
         CMP   #$0017
         BNE   L040210
         LDA   #$0002
         STA   L03CBA5
L040210  CLD
         ASL
         ASL
         ASL
         ASL
         SEP   #$20
         LDA   L03CBA5
         AND   #$0F
         REP   #$20
         CLC
         ADC   #$B0B0
         XBA
         STA   L03C92E+$C
         STA   L03C956+$B
         STA   L03C97D+$D
         STA   L03C9C0+$D
         LDA   L03CBA3
         DEC
         ASL
         TAY
         CLC
         LDA   #L012C7C
         ADC   L03CAA3,Y
         STA   L03C93E
         LDA   L03CBA3
         DEC
         ASL
         ASL
         TAY
         LDA   L03C9DF,Y
         STA   L03C99E
         LDA   L03C9DF+2,Y
         STA   L03C99E+2
         JSL   GSOS
         DW    $0010      ; Open
         ADRL  L03C973
         BCS   L04027F
         LDA   L03C973
         STA   L03C98C
         STA   L03C99A
         JSL   GSOS
         DW    $0012      ; Read
         ADRL  L03C98C
         JSL   GSOS
         DW    $0014      ; Close
         ADRL  L03C99A
         JSL   L020E70
L04027F  LDA   L030000
         BNE   L0402AF
         JSL   GSOS
         DW    $0010      ; Open
         ADRL  L03C924
         BCS   L0402B3
         LDA   L03C924
         STA   L03C93C
         STA   L03C94A
         JSL   GSOS
         DW    $0012      ; Read
         ADRL  L03C93C
         JSL   GSOS
         DW    $0014      ; Close
         ADRL  L03C94A
         BRA   L0402B3
L0402AF  JSL   L04032D
L0402B3  JSL   GSOS
         DW    $0010      ; Open
         ADRL  L03C94C
         BCS   L0402DC
         LDA   L03C94C
         STA   L03C963
         STA   L03C971
         JSL   GSOS
         DW    $0012      ; Read
         ADRL  L03C963
         JSL   GSOS
         DW    $0014      ; Close
         ADRL  L03C971
L0402DC  JSL   GSOS
         DW    $0010      ; Open
         ADRL  L03C99C
         BCS   L040305
         LDA   L03C99C
         STA   L03C9A6
         STA   L03C9B4
         JSL   GSOS
         DW    $0012      ; Read
         ADRL  L03C9A6
         JSL   GSOS
         DW    $0014      ; Close
         ADRL  L03C9B4
L040305  JSL   GSOS
         DW    $0010      ; Open
         ADRL  L03C9B6
         LDA   L03C9B6
         STA   L03C9CF
         STA   L03C9DD
         JSL   GSOS
         DW    $0012      ; Read
         ADRL  L03C9CF
         JSL   GSOS
         DW    $0014      ; Close
         ADRL  L03C9DD
         RTL

L04032D  LDA   L03CBA3
         DEC
         ASL
         TAY
         LDX   L03CB05,Y
L040336  LDA   |$0000,X
         BEQ   L04037C
         DEC
         ASL
         TAY
         CLC
         LDA   #L012C7C
         ADC   L03CAA3,Y
         STA   L03C93E
         LDA   L03CAE5,Y
         XBA
         STA   L03C92E+$C
         JSL   GSOS
         DW    $0010      ; Open
         ADRL  L03C924
         BCS   L040378
         LDA   L03C924
         STA   L03C93C
         STA   L03C94A
         JSL   GSOS
         DW    $0012      ; Read
         ADRL  L03C93C
         JSL   GSOS
         DW    $0014      ; Close
         ADRL  L03C94A
L040378  INX
         INX
         BRA   L040336
L04037C  RTL

L04037D  ENT
         REP   #$20
         LDA   #L03CBDB
         SEC
         SBC   #L03CB9B
         STA   L03C7AE
         LDA   L03CB9B
         CMP   L03CBA3
         BEQ   L040393
         BCS   L0403C0
L040393  LDA   L03CBA3
         STA   L03CB9B
         JSL   GSOS
         DW    $0010      ; Open
         ADRL  L03C78E
         LDA   L03C78E
         STA   L03C7A8
         STA   L03C8A7
         JSL   GSOS
         DW    $0013      ; Write
         ADRL  L03C7A8
         JSL   GSOS
         DW    $0014      ; Close
         ADRL  L03C8A7
L0403C0  JSL   GSOS
         DW    $0010      ; Open
         ADRL  L03C774
         LDA   L03C774
         STA   L03C7A8
         STA   L03C8A7
         JSL   GSOS
         DW    $0013      ; Write
         ADRL  L03C7A8
         JSL   GSOS
         DW    $0014      ; Close
         ADRL  L03C8A7
         RTL

L0403E8  ENT
         REP   #$20
         LDA   #L03CBDB
         SEC
         SBC   #L03CB9B
         STA   L03C7AE
         JSL   GSOS
         DW    $0010      ; Open
         ADRL  L03C774
         LDA   L03C774
         STA   L03C7A8
         STA   L03C8A7
         JSL   GSOS
         DW    $0012      ; Read
         ADRL  L03C7A8
         JSL   GSOS
         DW    $0014      ; Close
         ADRL  L03C8A7
         RTL

L04041C  ENT
         REP   #$20
         LDA   #L03CBDB
         SEC
         SBC   #L03CB9B
         STA   L03C7AE
         JSL   GSOS
         DW    $0010      ; Open
         ADRL  L03C78E
         LDA   L03C78E
         STA   L03C7A8
         STA   L03C8A7
         JSL   GSOS
         DW    $0012      ; Read
         ADRL  L03C7A8
         JSL   GSOS
         DW    $0014      ; Close
         ADRL  L03C8A7
         RTL

L040450  ENT
         REP   #$20
         LDA   #$0002
         STA   L03C7AE
         JSL   GSOS
         DW    $0010      ; Open
         ADRL  L03C78E
         LDA   L03C78E
         STA   L03C7A8
         STA   L03C8A7
         JSL   GSOS
         DW    $0012      ; Read
         ADRL  L03C7A8
         JSL   GSOS
         DW    $0014      ; Close
         ADRL  L03C8A7
         RTL

